print("Hello " .. UnitName("Player") .. " Kals_ClassicQuestTextToChat is running, type /qttc for options");


local Color_OBJECTIVE = "|CFF00ffff";
local Color_RED = "|CFFff0000";
local Color_QUEST_GOLD = "|CFFffff00";
local Color_NPC_TALK = "|CFFf8eca2";
local Color_PLAYER_TALK = "|CFF66ffff";

local OnlyShowObjective = false;

--Ideas
--Would be cool to have "Windrider Slacks" on npcs instead of just "Slacks"?
--print gossip when gossip option is selected, instead of printing all the choices!
--Add players response to chat

--bugs


local GossipText = CreateFrame("FRAME", "AddonFrame");
GossipText:RegisterEvent("GOSSIP_SHOW");

local function Gossip(self, event, ...)

	print("\n");
	print(Color_NPC_TALK .. UnitName("npc") .. ": \n" .. GetGossipText());
	print("\n");

	if(GetGossipOptions() ~= nil) then
		print(Color_OBJECTIVE .. "Gossip: ");
		print(Color_OBJECTIVE .. GetGossipOptions())
	end 
	
	if(GetGossipAvailableQuests() ~= nil)then
		--print("Available quests: " .. GetNumGossipAvailableQuests());

		print(Color_QUEST_GOLD .. "Quests: ");
		local x = -6;
		for i=1,GetNumGossipAvailableQuests() do
			x = x+7;
			print(Color_QUEST_GOLD .. tostring(select(x, GetGossipAvailableQuests())) .. " (lvl " ..  tostring(select(x+1, GetGossipAvailableQuests()) .. ")"));
		end
	end
end
GossipText:SetScript("OnEvent", Gossip);


--Quest details (before accepting)
local QuestText = CreateFrame("FRAME", "AddonFrame");
QuestText:RegisterEvent("QUEST_DETAIL");

local function QuestWaitingToAccept(self, event, ...)
	if (not OnlyShowObjective) then
		if ( event == "QUEST_DETAIL" and UnitName("npc") ~= nil) then

			print("\n");
			print(Color_QUEST_GOLD .. "*******************************************");
			print(Color_QUEST_GOLD .. "New Quest: " .. GetTitleText());
			print(Color_QUEST_GOLD .. "---------------------------------------------------------");
			print(Color_NPC_TALK .. UnitName("npc") .. ": \n" .. GetQuestText());
			print(Color_QUEST_GOLD .. "---------------------------------------------------------");
			print(Color_OBJECTIVE .. "Objective: \n" .. GetObjectiveText());
		end
	else
		print(Color_OBJECTIVE .. "Objective: " .. GetObjectiveText());
	end
			print("\n");
end
QuestText:SetScript("OnEvent", QuestWaitingToAccept);


--Quest Complete
local QuestCompletedText = CreateFrame("FRAME", "AddonFrame");
QuestCompletedText:RegisterEvent("QUEST_COMPLETE");

local function QuestCompleted(self, event, ...)
	if ( OnlyShowObjective == false and event == "QUEST_COMPLETE" ) then
		print("\n");
		print(Color_NPC_TALK .. UnitName("npc") .. ": " .. GetRewardText());
	end
end
QuestCompletedText:SetScript("OnEvent", QuestCompleted);

--Quest Removed
local QuestGreetingText = CreateFrame("FRAME", "AddonFrame");
QuestGreetingText:RegisterEvent("QUEST_GREETING");

local function QuestGreeting(self, event, ...)
	if ( OnlyShowObjective == false ) then
		if(GetGreetingText() ~= nil)then
			print("\n");
			print(Color_NPC_TALK .. GetGreetingText());
			print("\n");
		end

		print("Any gossip?");

		if(GetNumAvailableQuests() > 0)then
		--print("Available quests: " .. GetNumAvailableQuests());

		print(Color_QUEST_GOLD .. "Quests: ");
		local x = -6;
		for i=1,GetNumAvailableQuests() do
			x = x+7;
			print(Color_QUEST_GOLD .. GetAvailableTitle(i) .. " (lvl " .. GetAvailableLevel(i) .. ")");
		end
	end

	end
end
QuestGreetingText:SetScript("OnEvent", QuestGreeting);


local QuestHandedInText = CreateFrame("FRAME", "AddonFrame");
QuestHandedInText:RegisterEvent("QUEST_TURNED_IN");

local function QuestHandedIn(self, event, ...)
	if ( OnlyShowObjective == false and event == "QUEST_TURNED_IN" ) then
		print(Color_QUEST_GOLD .. "Quest complete!");
	end
end
QuestHandedInText:SetScript("OnEvent", QuestHandedIn);


--Quest Pogress
local QuestProgressText = CreateFrame("FRAME", "AddonFrame");
QuestProgressText:RegisterEvent("QUEST_PROGRESS");

local function QuestProgress(self, event, ...)
	if ( OnlyShowObjective == false and event == "QUEST_PROGRESS" ) then
		print(Color_NPC_TALK .. UnitName("npc") .. ":\n" .. GetProgressText());
	end
end
QuestProgressText:SetScript("OnEvent", QuestProgress);


 
--Book read
local BookText = CreateFrame("FRAME", "AddonFrame");
BookText:RegisterEvent("ITEM_TEXT_READY");

local function ReadBookItem(self, event, ...)
	if ( OnlyShowObjective == false) then
			print(Color_NPC_TALK .. "*******************************************");
			print(Color_NPC_TALK .. ItemTextGetItem() .. "\n" .. ItemTextGetText());
			print(Color_NPC_TALK .. "*******************************************");
	end
end
BookText:SetScript("OnEvent", ReadBookItem);











--Pressing continue
--local QuestContinueText = CreateFrame("FRAME", "AddonFrame");
--QuestContinueText:RegisterEvent("QUESTLINE_UPDATE");

--local function QuestContinue(self, event, ...)
	--if ( OnlyShowObjective == false and event == "QUESTLINE_UPDATE" ) then

	--end
--end
--QuestContinueText:SetScript("OnEvent", QuestContinue);

local CheckOnLoad = CreateFrame("FRAME", "AddonFrame");
CheckOnLoad:RegisterEvent("ADDON_LOADED");
CheckOnLoad:RegisterEvent("PLAYER_LOGOUT");

function CheckOnStart(self, event, ...)
	if(event == "ADDON_LOADED" and ... == "Kals_ClassicQuestTextToChat") then
		if(OnlyShowObjectiveGlobal == nil) then
			OnlyShowObjective = false;
		else
			OnlyShowObjective = OnlyShowObjectiveGlobal;
		end

		if(not OnlyShowObjective)then
			print("QuestTextToChat status: Showing all quest text");
		else
			print("QuestTextToChat status: Only showing quest objectives");
		end	
	end

	if( event == "PLAYER_LOGOUT") then
		OnlyShowObjectiveGlobal = OnlyShowObjective;
	end
end
CheckOnLoad:SetScript("OnEvent", CheckOnStart);


--CONSOLE
SLASH_QuestTextToChat1 = "/qttc";

SlashCmdList.QuestTextToChat = function(msg)
	msg = string.lower(msg);

	if(msg == "toggle") then
		OnlyShowObjective = not OnlyShowObjective;
		if(not OnlyShowObjective)then
			print("QuestTextToChat: Showing all quest text");
		else
			print("QuestTextToChat: Only showing quest objectives");
		end
	else
		print("QuestTextToChat: Type '/qttc toggle' to enable/disable only showing quest objectives");
	end
end 	